/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
        //app.db.database = window.sqlitePlugin.openDatabase({name: "RSA_DB_1", location: 'default'}, function(){app.db.init();}, function(){console.log("error db");});
        //app.db.init();
        app.deviceReady = true;
        if(device.platform === "iOS"){
            $('.ios-back-btn').show();
            $('#job-review-show-map').hide();
            $('#closeapp-btn').hide();
        }
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        console.log('Received Event: ' + id);
    },
    deviceReady: false,
    startPage: null,
    data: {
        currentTrip: null,
        currentJob: null,
        allowBack: true,
        currentJobExtId: null,
        currentTripExtId: null,
        isTracking: false
    },
    /**
     * namespace for pages
     * every jqm page has its own js-file which contains all of the logic that is required by this page
     */
    pages:  {
        dashboard: null,
        jobs: null,
        jobOverview: null,
        tripOverview: null,
        jobTracker: null,
        jobReview: null,
        imageProtocol: null,
        login: null,
        protocol: null,
        profile: null,
        newJob: null
    },
    panel: null,
    reset: function() {
    	app.data.currentTrip = null;
    	app.data.currentJob = null;
        app.data.allowBack = false;
        app.data.currentJobExtId = null;
        app.data.currentTripExtId = null;
    }
};

app.initialize();
var startPage = "#login";

$(document).ready(function(event){
    console.log("document ready");
    document.addEventListener("deviceready", app.onDeviceReady, false);
    window.setTimeout(function(){
        $.mobile.loading('hide');
        $('#overlay').remove();
        $.mobile.changePage(startPage);
    }, 3000);
});
