/**
 * Created by christiankalig on 05.07.16.
 */

var app = app || {};

var JobOverview = (function(){
    var instance;
    var textarea = "";
    var baseUrl = "";
    function init(){
    	
    	
    	
        // private
        $('#job-overview-start-trip').click(function(event){
            textarea = $('#job-overview-textarea').val();
            app.db.executeSql("INSERT INTO trip (job_id, start, user_id, note) VALUES (?, ?, ?, ?)", [app.data.currentJob, new Date(), 1, textarea], onTripStarted);
        });

        function getEmails() {
                app.db.getLoginData(function(username, authkey){
                $.ajax({
                     method: "GET",
                     url: localStorage.getItem("base_url") + "api/jobs/getemails",
                     data: {
                        user: username,
                        token: authkey,
                        id: app.data.currentJobExtId,
                     },
                     dataType: 'json',
                     xhrFields: {
                         withCredentials: true
                     },
                     success: function(result){
                        if (result.success) {
                            $('#emails-select').empty();
                            var emails = result.data.job;
                            emails.forEach(function(email, index) {
                                if (email != '') {
                                    $('#emails-select').append("<option value='"+email+"'>"+email+"</option>");
                                }
                            });
                            $('#emails-select').val($('#emails-select option:first-child').val());
                            $('#emails-select option:first-child').prop("selected", true);
                            console.log("EMAIL AFTER SET VALUE: "+$('#emails-select').val());
                            $('#emails-select').selectmenu("refresh");
                            console.log("EMAIL AFTER SET VALUE AND REFRESH: "+$('#emails-select').val());
                            $('#emails-select').val($('#emails-select option:first-child').val());
                            console.log("EMAIL AFTER SET VALUE AND REFRESH AND AGAIN SET VALUE: "+$('#emails-select').val());
                        }
                     },
                     error: function(e){
                         app.utils.debug.log(app.utils.debug.debugPages.JOB_OVERVIEW, e, "ERROR");
                     }
                });
            });
        }//

        function onTripStarted(result){
            app.utils.debug.log(app.utils.debug.debugPages.JOB_OVERVIEW, "trip started", "INFO", result.insertId);
            app.data.currentTrip = result.insertId;
            app.utils.debug.log(app.utils.debug.debugPages.JOB_OVERVIEW, app.data.currentTrip);
            startTripOnServer();
        }

        function startTripOnServer() {
            var email = $('#emails-select').val();
            console.log("%cEMAIL: %s", "color: red;", email);
            $.mobile.loading("show", {
                text: "Kontrollfahrt wird gestartet",
                textVisible: true
            });
            app.db.getLoginData(function(username, authkey){
	            $.ajax({
		             method: "GET",
		             url: localStorage.getItem("base_url") + "api/trip/start",
		             data: {
		               	user: username,
		               	token: authkey,
		                jobId: app.data.currentJobExtId,
		                start: true,
                        note: textarea,
		                email: email
		             },
		             dataType: 'json',
		             xhrFields: {
		            	 withCredentials: true
		             },
		             success: function(result){
		            	 app.utils.debug.log(app.utils.debug.debugPages.JOB_OVERVIEW, result);
		                 if (result.success && result.data.trip.id > 0) {
		                	app.data.currentTripExtId = result.data.trip.id;
		                	app.pages.jobTracker.showProtocol(result.data.trip.showProtocol);
		                	console.log(result);
		                    app.utils.debug.log(app.utils.debug.debugPages.JOB_OVERVIEW, "ext id: " + result.data.trip.id);
		                    app.db.executeSql("update trip set external_id=? where id=?", [app.data.currentTripExtId, app.data.currentTrip], function(){
                                $.mobile.changePage("#job-tracker");
                                $.mobile.loading("hide");
                                reset();
                            });
		                 }
		                 else {
		                	 alert('Achtung: Fahrt wurde auf dem Server nicht gestartet! Bitte überprüfen Sie Ihre Internet-Verbindung und starten Sie eine neue Fahrt.');
		                 }
		                 //start tracking if not started yet
		                 if (!app.pages.jobTracker.getIsTracking()) {
		                	 app.pages.jobTracker.start();
		                 }
		             },
		             error: function(e){
		                 app.utils.debug.log(app.utils.debug.debugPages.JOB_OVERVIEW, e, "ERROR");
		                 alert('Die Fahrt konnte im Server nicht gestartet werden. Technische Fehlermeldung: ' + e);
		             }
	            });

	            textarea = "";
            });
        }/// startTripOnServer -------------------- END

        function reset(){
            $('#job-overview-textarea').val("");
            $('#emails-select').val("");
        }

        function onJobDataLoaded(result){
            app.utils.debug.log(app.utils.debug.debugPages.JOB_OVERVIEW, "job data loaded successful");
            var item = result.rows.item(0);
            getEmails();
            $('#job-overview-job-id').text(item.id);
            $('#job-overview-address').text(item.address);
            $('#job-overview-client').text(item.customer_name);
            $('#job-overview-date').text(item.creation_date);
            //TODO: save act user somewhere and retrieve data
            $('#job-overview-username').text("Max Mustermann");
            $.mobile.changePage('#job-overview');
        }

        //public
        return {
            onCreate: function(){

            },
            beforeShow: function(){

            },
            beforeHide: function(){
                console.log("JOB_OVERVIEW BEFORE HIDE");
            },
            loadJobData: function(id){
                app.utils.debug.log(app.utils.debug.debugPages.JOB_OVERVIEW, "load job data for id: "+id);
                app.db.executeSql("SELECT j.* FROM job j WHERE j.id = ?", [id], function(result){
                    onJobDataLoaded(result);
                });
            }
        }
    }

    return {
        getInstance: function(){
            if(!instance){
                instance = init();
            }
            return instance;
        }
    }
})();
