/**
 * Created by christiankalig on 15.06.16.
 */

var app = app || {};

var Login = (function(){
    var instance;


    function init(){
        //Singleton
        //private

        var url = localStorage.getItem("base_url");
        var func = "validateLogin";
        var handler = "LoginHandler";
        var keepSignedIn = false;
        var username = "";
        function onLoginAction(){
            $.mobile.loading("show", {
                text: "Sie werden eingeloggt",
                textVisible: true
            });
            username = $('#login-username').val();
            var password = $('#login-password').val();
            keepSignedIn = $('#login-keep-me-signed-in').is(':checked');
            app.utils.debug.log(app.utils.debug.debugPages.LOGIN, "Try login");
            $.ajax({
                method: "POST",
                url: url + "api/user/login",
                data: {
                    user: username,
                    password: password,
                    authkey: "",
                    func: func,
                    class: handler
                },
                dataType: 'json',
                xhrFields: {
                    withCredentials: true
                },
                success: function(result){
                    app.utils.debug.log(app.utils.debug.debugPages.LOGIN, result);
                    if(result.success){
                        onLoginSuccessful(result, true, true);
                    } else {
                        new $.nd2Toast({ // The 'new' keyword is important, otherwise you would overwrite the current toast instance
                            message : "Login nicht möglich", // Required
                            ttl : 3000 // optional, time-to-live in ms (default: 3000)
                        });
                        $.mobile.loading("hide");
                    }
                },
                error: function(e){
                    app.utils.debug.log(app.utils.debug.debugPages.LOGIN, e);
                    new $.nd2Toast({ // The 'new' keyword is important, otherwise you would overwrite the current toast instance
                        message : "Login nicht möglich", // Required
                        ttl : 3000 // optional, time-to-live in ms (default: 3000)
                    });
                    $.mobile.loading("hide");
                }
            });
        }

        function onLoginSuccessful(result, redirect, loginform){
            if(result.data != null){
            	app.db.setMeta("user_authkey", result.data.token);
            }
            $('#user_name').html(result.data.name);
            app.db.setMeta("user_loginname", result.data.username);
            app.db.setMeta("user_id", -1);
            if (loginform) {
            	app.db.setMeta("user_keep_signed_in", app.pages.login.keepSignedIn);
            }
            app.db.setMeta("user_login_timestamp", Date.now());
            startPage = "#index";
            if(redirect){
                $.mobile.changePage("#index");
            }
            $.mobile.loading("hide");
        }

        function onAuthkeyLoginAction(){
        	app.db.getLoginData(function(username, authkey){
                app.utils.debug.log(app.utils.debug.debugPages.LOGIN, "AUTHKEY: "+authkey);
                app.utils.debug.log(app.utils.debug.debugPages.LOGIN, "username: "+username);
                if(authkey && username){
                    //try to login by authkey
                    $.ajax({
                        method: 'POST',
                        url: localStorage.getItem("base_url")+"api/user/login",
                        data: {
                            func: "byauthkey",
                            authkey: authkey,
                            user: username
                        },
                        dataType: 'json',
                        success: function(result){
                            app.utils.debug.log(app.utils.debug.debugPages.LOGIN, result);
                            if(result.success){
                                onLoginSuccessful(result, false, false);
                            } else {
                                app.utils.debug.log(app.utils.debug.debugPages.LOGIN, "Authkey Authentication not successful");
                            }
                        },
                        error: function(e){
                            app.utils.debug.log(app.utils.debug.debugPages.LOGIN, e);
                        }
                    });
                } else {
                    app.utils.debug.log(app.utils.debug.debugPages.LOGIN, "AUTHKEY COULD NOT BE LOADED");
                    return false;
                }
            });
        }

        //public
        return {
            onCreate: function(){
                app.utils.debug.log(app.utils.debug.debugPages.LOGIN, "button bound to onLoginAction");
                $('#login-submit').click(function(event){
                     event.preventDefault();
                     onLoginAction();
                 });
                $('#change-baseurl').click(function(event){
                    event.preventDefault();
                    $('#baseUrlForm').toggle();
                    $('#submit-form').toggle();
                });
                $('#baseurl-submit').click(function(event){
                    event.preventDefault();
                    if ($('#baseurl-input').val() == "") {
                    	$('#baseurl-input').focus().select();
                    }
                    else {
	                    $('#baseUrlForm').toggle();
	                    $('#submit-form').toggle();
	                    if (!$('#baseurl-input').val().endsWith('/')) {
	                    	$('#baseurl-input').val($('#baseurl-input').val() + '/');
	                    }
	                    localStorage.setItem("base_url", $('#baseurl-input').val());
	                    location.reload();
                    }
                });
            },
            onShow: function(){
            	app.utils.debug.log(app.utils.debug.debugPages.LOGIN, "try authkey login");
                onAuthkeyLoginAction();
            }
        }

    }

    return {
        getInstance: function(){
            if(!instance){
                instance = init();
            }
            return instance;
        }
    }
})();
