/**
 * Created by christiankalig on 06.08.16.
 */
var app = app || {};

var NewJob = (function(){
    var instance;

    function init(){
        // private
        var var_private = "private";

        var newJobBtn = $('#jobs-new-job-button');
        newJobBtn.click(function(event){
            getCustomers();
        });

        function getCustomers() {
                app.db.getLoginData(function(username, authkey){
                $.ajax({
                     method: "GET",
                     url: localStorage.getItem("base_url") + "api/customer/getall",
                     data: {
                        user: username,
                        token: authkey,
                     },
                     dataType: 'json',
                     xhrFields: {
                         withCredentials: true
                     },
                     success: function(result){
                        if (result.success) {
                            $('#new-job-customer-name').empty();
                            var namesArray = new Array();
                            var idsArray = new Array();
                            result.data.customers.forEach(function(customer, index) {
                                namesArray.push(customer.displayName);
                                idsArray.push(customer.id);
                            });
                            var sel = document.getElementById('new-job-customer-name');
                            var fragment = document.createDocumentFragment();
                            namesArray.forEach(function(name, index) {
                                var opt = document.createElement('option');
                                opt.innerHTML = name;
                                opt.value = idsArray[index];
                                fragment.appendChild(opt);
                            });
                            sel.appendChild(fragment);
                            console.log($('#new-job-customer-name option:first-child'));
                            $('#new-job-customer-name option:first-child').prop("selected", true);
                            $('#new-job-customer-name').selectmenu("refresh");
                        }
                     },
                     error: function(e){
                         app.utils.debug.log(app.utils.debug.debugPages.JOB_OVERVIEW, e);
                     }
                });
            });
        }//

        // Function that validates email address through a regular expression.
        function validateEmail(sEmail) {
            var filter = /^[\w\-\.\+]+\@[a-zA-Z0-9\.\-]+\.[a-zA-z0-9]{2,4}$/;
            if (filter.test(sEmail)) {
                return true;
            }
            else {
                return false;
            }
        }//

        function storeLocal(customer, address, description){
            app.db.executeSql("INSERT INTO job (customer_name, address, description) VALUES (?, ?, ?)", [customer, address, description], function(result){
                console.log("Neuer Auftrag gespeichert!");
            });
        }

        function storeExternal(){
            var jobcustomer = $('#new-job-customer-name').val();
            var city = $('#new-job-customer-address-city').val();
            var street = $('#new-job-customer-address-street').val();
            var email1 = $('#new-job-customer-address-email1').val();
            var work = $('#new-job-customer-address-work').val();
            var type = $('#new-job-customer-address-type').val();
            var phone = $('#new-job-customer-address-phone').val();
            var phone2 = $('#new-job-customer-address-phone2').val();
            var description = $('#new-job-customer-description').val();

            app.db.getLoginData(function(username, authkey){
                $.ajax({
                     method: "GET",
                     url: localStorage.getItem("base_url") + "api/jobs/add",
                     data: {
                        user: username,
                        token: authkey,
                        jobcustomer: jobcustomer,
                        city: city,
                        street: street,
                        email1: email1,
                        work: work,
                        type: type,
                        phone: phone,
                        phone2: phone2,
                        description: description,
                     },
                     dataType: 'json',
                     xhrFields: {
                         withCredentials: true
                     },
                     success: function(result){
                        if (result.success) {
                            console.log("Neuer Auftrag gespeichert!");
                            reset();
                            app.pages.jobs.show();
                            $.mobile.changePage('#jobs');
                        }
                        else {
                        	console.error(result);
                        	alert('Auftrag konnte nicht angelegt werden. Technische Fehlermeldung: '+result.error);
                        }
                     },
                     error: function(e){
                         app.utils.debug.log(app.utils.debug.debugPages.JOB_OVERVIEW, e);
                     }
                });
            });
        }

        function reset(){
            $('#new-job-customer-name').val("");
            $('#new-job-customer-address-city').val("");
            $('#new-job-customer-address-street').val("");
            $('#new-job-customer-address-email1').val("");
            $('#new-job-customer-address-work').val("");
            $('#new-job-customer-address-type').val("");
            $('#new-job-customer-address-phone').val("");
            $('#new-job-customer-address-phone2').val("");
            $('#new-job-customer-description').val("");
        }

        //public
        return {
            onShow: function() {
                getCustomers();
            },
            onSaveCommand: function(customer, address, description){
                // storeLocal(customer, address, description);
                var email1 = $('#new-job-customer-address-email1').val();
                if (validateEmail(email1)) {
                    storeExternal();
                }
                else {
                    alert('E-Mail-Adresse konnte nicht validiert werden.');
                }
            }
        }
    }

    return {
        getInstance: function(){
            if(!instance){
                instance = init();
            }
            return instance;
        }
    }
})();
