/**
 * Created by christiankalig on 09.08.16.
 */
var app = app || {};

var Profile = (function(){
    var instance;

    function init(){
        // private
        var options = {
            drawOnly: true,
            bgColor: 'transparent',
            lineTop: 70,
            penColour: '#000000',
            penWidth: 3,
            lineWidth: 3
        },
            baseUrl;
        var api = $('.sigPad').signaturePad(options);
        baseUrl = localStorage.getItem("base_url");

        function restore(){
            app.db.getMeta("signature", function(signature){
                if(signature){
                    api.regenerate(signature);
                }
            });
        }

        function clearSignature(){
            api.clearCanvas();
        }

        function save(){
            app.db.setMeta("signature", api.getSignatureString());
            app.db.getLoginData(function(username, authkey){
                $.ajax({
                    method: "POST",
                    url: baseUrl+"api/user/addsignature",
                    data: {
                        user: username,
                        token: authkey,
                        img_data: api.getSignatureImage(),
                        name: "Signature",
                        mime: "image/png"
                    },
                    dataType: "json",
                    success: function(result){
                        console.log(result);
                        new $.nd2Toast({ // The 'new' keyword is important, otherwise you would overwrite the current toast instance
                            message : "Signatur gespeichert und hochgeladen", // Required
                            ttl : 3000 // optional, time-to-live in ms (default: 3000)
                        });
                    },
                    error: function(e){
                        console.log(e);
                        new $.nd2Toast({ // The 'new' keyword is important, otherwise you would overwrite the current toast instance
                            message : "Fehler beim Übertragen der Signatur", // Required
                            ttl : 3000 // optional, time-to-live in ms (default: 3000)
                        });
                    }
                });
            });
        }

        //public
        return {
            onClear: function(){
                clearSignature();
            },
            onSave: function(){
                save();
            },
            onShow: function(){
                console.log("\nPROFILE\non show called");
                restore();
            }
        }
    }

    return {
        getInstance: function(){
            if(!instance){
                instance = init();
            }
            return instance;
        }
    }
})();
