/**
 * Created by christiankalig on 11.05.16.
 */

$(document).on("pagecontainerbeforeshow", function(event, ui){
    console.log(ui);
    if(ui.toPage.is("#note-protocol")){
        app.pages.protocol.beforeShow(app.pages.jobTracker.getIsTracking());
    }
});

$(document).ready(function(event){
	var url = localStorage.getItem("base_url");
	console.log(url);
	if (url == null) {
		console.log("base url is null");
		//url = "http://ztv-sa.4e-software.de/";
		url = "http://www.rsa-app.de/app.php/";
		localStorage.setItem("base_url", url);
	}
    $('#baseurl-input').val(url);
    
    /**
     * wait for the device to be ready and fill our global namespace with the related instances
     * and wire their ui elements to related actions and events
     */
    document.addEventListener("deviceready", function(){
        //var app = app || {};

        /**
         * Database instanciation
         */
        app.db = Database.getInstance();

        /**
         * Utils instanciation
         */
        app.utils = Utils.getInstance();

        /**
         * Panel instanciation
         */
        app.panel = Panel.getInstance();
        $('.panel-btn').click(function(event, ui){
            $('#leftpanel').panel('toggle');
        });

        $('#logout-btn').click(function(event, ui){
        	navigator.notification.confirm(
        		    'Wirklich abmelden?', // message
        		     onConfirmLogoutApp,            // callback to invoke with index of button pressed
        		    'Abmelden',           // title
        		    ['Ja','Nein']     // buttonLabels
        		);
        });

        /**
         * called to logout the current user
         */
        function onConfirmLogoutApp(index) {
        	if (index == 2) {
        		return;
        	}
        	app.db.setMeta('user_authkey', '');
        	app.reset();
        	startPage = "#login";
        	$.mobile.changePage(startPage);
        }

        /**
         * bind events to the panel to make sure that clicks on the panel don't bleed through while overlaying the Google Maps map
         * (achieved by calling the maps function setClickable wrapped in the pages.jobReview object)
         * (currently not needed because the map is displayed in fullscreen mode,
         *  but maybe we want to display the map somewhere else in future versions)
         */
        $('#leftpanel').panel({
            beforeopen: function(event, ui){
                app.pages.jobReview.setClickable(false);
            },
            beforeclose: function(event, ui){
                app.pages.jobReview.setClickable(true);
            }
        });
        $('#panel-jobs-btn').click(function(event, ui){
            app.pages.jobs.show();
        });

        $('#closeapp-btn').click(function(event, ui) {
        	confirmClose();
        });
        
        function open_native_file(nativeURL) {
        	console.log(nativeURL);
        	cordova.InAppBrowser.open(nativeURL, '_blank', 'location=no');
        }
        
        function email_native_file(nativeURL) {
        	window.plugins.Base64.encodeFile(nativeURL, function(base64){
	 			console.log('file base64 encoding: ' + base64);
	        	cordova.plugins.email.open({
				    attachments: "base64:log.txt" + base64.replace("data:image/*;charset=utf-8;base64,", "//"),
	        		subject: 'RSA // Log-Datei senden',
				    body:    'Im Anhang befindet sich eine Log-Datei.'
				});
	 		});
        }
        
        $('#load-logs-btn').on('click', function() {
        	$('#logs-content').html('Logs werden geladen...');
        	window.resolveLocalFileSystemURL(cordova.file.dataDirectory, function(dir) {
        		console.log("got main dir",dir);
        		var reader = dir.createReader();
        		reader.readEntries(
        			function (entries) {
        				var tmp = "<table>";
        				for(var i=0; i<entries.length; i++) {
        					var file = entries[i];
        					console.log(file);
        					if (file.isFile && file.name.startsWith("log_")) {
        						if (tmp == "") {
        							tmp = '<table style="width:75%;"><thead><tr><th>Name</th></th></thead><tbody>';
        						}
        						tmp += '<tr style="line-height:2.4em;"><td>'+file.name+'</td><td><a href="#" class="open-file" data-nativeurl="'+
        							file.nativeURL+'" target="_blank">Anzeigen</a> <a href="#" class="email-file" data-nativeurl="'+
        							file.nativeURL+'" target="_blank">E-Mail</a></td></tr>';
        					}
        				}
        				if (tmp == "") {
        					$('#logs-content').html('Noch keine Log-Dateien verfügbar.');
        				}
        				else {
        					$('#logs-content').html(tmp + '</tbody></table>');
        					$('.open-file').on('click', function() {
        						open_native_file($(this).data('nativeurl'));
        					});
        					$('.email-file').on('click', function() {
        						email_native_file($(this).data('nativeurl'));
        					});
        				}
        			},
        			function (err) {
        				console.error(err);
        			}
        		);
        	});
        });
        
        /**
         * asks whether the app should really be closed
         */
        function confirmClose() {
        	navigator.notification.confirm(
        		    'Anwendung wirklich beenden?', // message
        		     onConfirmExitApp,            // callback to invoke with index of button pressed
        		    'Anwendung beenden',           // title
        		    ['Ja','Nein']     // buttonLabels
        		);
        }

        /**
         * closes the application
         */
        function onConfirmExitApp(btn) {
        	if (btn == 1) {
	        	if (navigator.app) {
	        		navigator.app.exitApp();
	        	}
	        	else if (navigator.device) {
	        		navigator.device.exitApp();
	        	}
	        	else {
	        	    window.close();
	        	}
        	}
        }



        /**
         * Dashboard instanciation
         */
        app.pages.dashboard = Dashboard.getInstance();
        $('#index').pagecontainer({
            create: function(){
                app.pages.dashboard.onCreate();
            }
        });

        /**
         * JobOverviewPage instanciation
         */
        app.pages.jobOverview = JobOverview.getInstance();
        $('#job-overview').pagecontainer({
            beforehide: app.pages.jobOverview.beforeHide()
        });

        /**
         * JobReviewPage instanciation
         */
        app.pages.jobReview = JobReview.getInstance();
        $('#job-review').pagecontainer({
            create: app.pages.jobReview.onCreate(),
            beforeshow: app.pages.jobReview.beforeShow(),
            beforehide: app.pages.jobReview.beforeHide()
        });

        /**
         * JobsPage instanciation
         */
        app.pages.jobs = Jobs.getInstance();
        $('#jobs-new-job-button').click(function(event, ui){
            $.mobile.changePage("#new-job");
        });

        /**
         * JobTrackerPage instanciation
         */
        app.pages.jobTracker = JobTracker.getInstance();
        $('#job-tracker').pagecontainer({
            beforeshow: app.pages.jobTracker.beforeShow(),
            beforehide: app.pages.jobTracker.beforeHide()
        });

        /**
         * LoginPage instanciation
         */
        app.pages.login = Login.getInstance();
        $('#login').pagecontainer({
            create: app.pages.login.onCreate(),
            beforeshow: app.pages.login.onShow()
        });

        /**
         * TripOverviewPage instanciation
         */
        app.pages.tripOverview = TripOverview.getInstance();
        $('#trip-overview').pagecontainer({
            beforeshow: app.pages.tripOverview.beforeShow()
        });

        app.synchronisator = Synchronisator.getInstance();
        app.synchronisator.startSynchronisation();
        $(document).on("start_tracking", function(){
            console.log("received start_tracking event");
            //app.synchronisator.startSynchronisation();
        });

        $(document).on("stop_tracking", function(){
            console.log("received stop_tracking event");
            //app.synchronisator.stopSynchronisation();
        });

        /**
         * Protocol instanciation
         */
        app.pages.protocol = Protocol.getInstance();

        $(document).on("change", ".flippy-flip", function(e) {
            console.log("change");
            app.pages.protocol.onSelectChangeInsideTab();
        });

        $('.flippy-flip select').change(function(event){
            console.log("change");
            app.pages.protocol.onSelectChangeInsideTab();
        });

        $('#note-protocol').pagecontainer({
            beforeshow: function(event, ui){console.log("PROTOKOLL: beforeshow");}
            //beforeshow: app.pages.protocol.beforeShow(app.pages.jobTracker.getIsTracking())
        });

        $('#note-protocol-save-btn').click(function(event){
            event.preventDefault();
            app.pages.protocol.onSaveProtocolAction();
            app.pages.jobReview.showMap();
        });

        /**
         * NewJobs Page instanciation
         */
        app.pages.newJob = NewJob.getInstance();
        $('#new-job-save').click(function(event, ui){
            var customer,
                address,
                description;
            customer = $('#new-job-customer-name').val();
            address = $('#new-job-customer-address-street').val() +
                      " " +
                      $('#new-job-customer-address-zip').val() +
                      " " +
                      $('#new-job-customer-address-city').val();
            description = $('#new-job-customer-description').val();
            app.pages.newJob.onSaveCommand(customer, address, description);
        });


        var userNameClickCounter = 0;

        /**
         * function for starting/stopping printing out debug messages
         */
        $('#user_name').dblclick(function() {
        	userNameClickCounter++;
        	if (userNameClickCounter >= 3) {
        		app.utils.debug.debugger = !app.utils.debug.debugger;
        		userNameClickCounter = 0;
        		new $.nd2Toast({ message : "Debug: " + app.utils.debug.debugger, ttl : 1000 });
        	}
        });

        app.pages.profile = Profile.getInstance();
        
        $('#profile-save-signature').click(function(event, ui){
            app.pages.profile.onSave();
        });

        $('#profile-clear-signature').click(function(event, ui){
            app.pages.profile.onClear();
        });

        $('#panel-profile-btn').click(function(event, ui){
            app.pages.profile.onShow();
        });

        document.addEventListener("backbutton", function(){
            console.log("backbutton on page "+$.mobile.activePage.attr('id'));
            if ($.mobile.activePage.attr('id') == "job-tracker" || app.data.isTracking) {
                //ask for finishing job
                app.pages.jobTracker.confirmEndTrip();
                return;
            }
            else {
                app.reset();
                switch($.mobile.activePage.attr('id')){
                    case "jobs":
                        $.mobile.changePage(startPage);
                        break;
                    case "new-job":
                        $.mobile.changePage("#jobs");
                        break;
                    case "trip-overview":
                        $.mobile.changePage("#jobs");
                        break;
                    case "job-review":
                        app.pages.jobs.show();
                        break;
                    case "index":
                        confirmClose();
                        break;
                    case "login":
                        confirmClose();
                        break;
                    case "note-protocol":
                        var isTracking = app.pages.jobTracker.getIsTracking();
                        if(isTracking){
                            $.mobile.changePage("#job-tracker");
                        }
                        break;
                    default:
                        $.mobile.changePage(startPage);
                        break;
                }
            }
        }, false);

    }, false);
});

